<template>
  <q-page padding class="q-mx-md">
    <components-cylinder-details />
    <div class="row full-width q-my-md justify-end q-gutter-sm">
        <q-btn no-caps flat color="negative" text-color-white label="Delete" @click="pendingIntent = 'delete'"/>
        <q-btn no-caps color="secondary" text-color="white" :label="'View ' + requestsNumber + ' requests'" @click="pendingIntent = 'view'"/>
    </div>
    <q-form class="row justify-end" v-if="pendingIntent" @submit="executePendingIntent">
      <div class="col-12 col-md-4">
        <q-input
          v-model="passcode"
          label="Secret passcode"
          :rules="[ val => val && val.length === 6 || 'Please enter the passcode.']"
        />
        <div class="row justify-end">
          <q-btn
            color="primary"
            label="Proceed"
            type="submit"
          />
        </div>
      </div>
    </q-form>
    <div class="row q-my-md bg-grey-3 q-pa-md rounded-borders items-center" v-for="(request, index) in requestData" :key="index">
      <span class="col-1 col-md-1">
        {{ index + 1 }}.
      </span>
      <span class="col-11 col-md-3 text-body1">
        <q-icon name="mdi-account"/>
        {{ request.rp_name }}
      </span>
      <span class="col-6 col-md-3 text-body1">
        <q-icon name="mdi-cellphone"/>
        <a :href="'tel:\/\/+91' + request.rp_phone">{{ request.rp_phone }}</a>
      </span>
      <span class="col-6 col-md-2 text-body1">
        <q-icon name="mdi-scale"/>
        Required capacity: {{ request.rp_quantity }}L
      </span>
      <span class="col-12 col-md-3 text-body1">
        <q-icon name="mdi-map-marker"/>
        {{ request.rp_city }}, {{ request.rp_state }} - {{ request.rp_pincode }}
      </span>
      <span class="col-12 col-md-3 text-body1">
        <q-icon name="mdi-calendar-clock"/>
        {{ request.modified_on }}
      </span>
      <q-separator/>
    </div>
  </q-page>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-call */
import { defineComponent } from '@vue/composition-api'
import ComponentsCylinderDetails from 'components/CylinderDetails'
export default defineComponent({
  name: 'ShowCase',

  components: {
    ComponentsCylinderDetails
  },

  data () {
    return {
      requestData: [],
      requestsNumber: '',
      passcode: '',
      pendingIntent: ''
    }
  },

  mounted () {
    this.getCylinderRequestsNumber()
  },

  methods: {
    executePendingIntent: function () {
      if (this.pendingIntent === 'view') {
        this.getCylinderRequests()
      } else if (this.pendingIntent === 'delete') {
        this.deleteCylinder()
      }
    },

    getCylinderRequests: function () {
      this.$axios.get(`/api/cylinders/${this.$route.params.id}/requests?phone=${this.$route.query.phone}&passcode=${this.passcode}`)
        .then((response) => {
          // this.requestData = response.data
          this.requestData.push(...response.data)
          // this.requestData.push(response.data)
          // this.$set(this.requestData, response.data)
          console.log(this.requestData)
          this.pendingIntent = ''
        })
        .catch((error) => {
          console.log(error)
        })
    },

    getCylinderRequestsNumber: function () {
      this.$axios.get(`/api/cylinders/${this.$route.params.id}/requests/number`)
        .then((response) => {
          this.requestsNumber = response.data
        })
        .catch((error) => {
          console.log(error)
        })
    },

    deleteCylinder: function () {
      this.$axios.put(`/api/cylinders/${this.$route.params.id}`, {
        phone: this.$route.query.phone,
        passcode: this.passcode
      }).then((response) => {
        if (response) {
          this.$q.notify({
            message: 'Thank you for helping a fellow Indian',
            color: 'positive'
          })
          this.$router.push('/')
        }
      }).catch((error) => {
        console.log(error)
      })
    }
  }
})
</script>
